﻿/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007 – 2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

using System;
using System.Collections.Generic;
using Eisk.BusinessEntities;
namespace Eisk.BusinessLogicLayer.Strategies
{
    public interface IEmployeeBLL : IDisposable
    {
        Employee GetEmployeeByEmployeeId(int employeeId);

        List<Employee> GetEmployeesByReportsTo(int? reportsTo);
        List<Employee> GetEmployeesByReportsToPaged(int? reportsTo, string orderBy, int startRowIndex, int maximumRows);
        int GetTotalCountForAllEmployeesByReportsTo(int? reportsTo, string orderBy, int startRowIndex, int maximumRows);

        List<Employee> GetAllEmployees();
        List<Employee> GetAllEmployeesPaged(string orderBy, int startRowIndex, int maximumRows);
        int GetTotalCountForAllEmployees(string orderBy, int startRowIndex, int maximumRows);
        
        int CreateNewEmployee(Employee newEmployee);
        void UpdateEmployee(Employee updatedEmployee); 
        void DeleteEmployee(Employee employeeToBeDeleted);
        void DeleteEmployees(List<int> employeesIdsToDelete);
        
    }
}
