/****** Object:  StoredProcedure [dbo].[Custom_Employees_GetAllEmployeesWithSupervisors]    Script Date: 03/18/2010 14:51:39 ******/
SET ANSI_NULLS ON
/**/
SET QUOTED_IDENTIFIER ON
/**/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Custom_Employees_GetAllEmployeesWithSupervisors]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [dbo].[Custom_Employees_GetAllEmployeesWithSupervisors] 
AS
	SET NOCOUNT ON
	SELECT     
	Emp.EmployeeID, 
	Emp.FirstName, 
	Emp.LastName, 
	Supervisors.FirstName as SupervisorFirstName,
	Supervisors.LastName as SupervisorLastName
	
	FROM Employees AS Supervisors INNER JOIN Employees AS Emp ON Supervisors.EmployeeId = Emp.ReportsTo
' 
END
/**/
/****** Object:  StoredProcedure [dbo].[Custom_Employees_GetAllTopAndGeneralEmployees]    Script Date: 03/18/2010 14:51:39 ******/
SET ANSI_NULLS ON
/**/
SET QUOTED_IDENTIFIER ON
/**/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Custom_Employees_GetAllTopAndGeneralEmployees]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [dbo].[Custom_Employees_GetAllTopAndGeneralEmployees] 
AS
SET NOCOUNT ON

-- Get top level employees
SELECT EmployeeID,LastName,FirstName,Title,TitleOfCourtesy,BirthDate,HireDate,Address,City,Region,PostalCode,Country,HomePhone,Extension,Photo,Notes,ReportsTo,PhotoPath
FROM Employees
WHERE ReportsTo is NULL OR EmployeeID = ReportsTo

-- Get general employees
SELECT     
	Emp.EmployeeID, 
	Emp.FirstName, 
	Emp.LastName, 
	Supervisors.FirstName as SupervisorFirstName,
	Supervisors.LastName as SupervisorLastName
	FROM Employees AS Supervisors INNER JOIN Employees AS Emp ON Supervisors.EmployeeId = Emp.ReportsTo
	WHERE Emp.ReportsTo is NOT NULL AND Emp.EmployeeID <> Emp.ReportsTo

	' 
END
/**/
/****** Object:  StoredProcedure [dbo].[Custom_Employees_GetEmployeesByFilterParams]    Script Date: 03/18/2010 14:51:39 ******/
SET ANSI_NULLS ON
/**/
SET QUOTED_IDENTIFIER ON
/**/
IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[Custom_Employees_GetEmployeesByFilterParams]') AND type in (N'P', N'PC'))
BEGIN
EXEC dbo.sp_executesql @statement = N'CREATE PROCEDURE [dbo].[Custom_Employees_GetEmployeesByFilterParams] 
@lastName nvarchar(20), 
@firstName nvarchar(10), 
@city nvarchar(15), 
@region nvarchar(20), 
@country nvarchar(15) 
AS
SET NOCOUNT ON

SELECT EmployeeID,LastName,FirstName,Title,TitleOfCourtesy,BirthDate,HireDate,Address,City,Region,PostalCode,Country,HomePhone,Extension,Photo,Notes,ReportsTo,PhotoPath
FROM Employees
WHERE 
	/*LastName LIKE ''%'' + @lastName + ''%'' AND
	FirstName LIKE ''%'' + @firstName + ''%'' AND
	City LIKE ''%'' + @city + ''%'' AND
	Region LIKE ''%'' + @region + ''%'' AND
	Country LIKE ''%'' + @country + ''%''*/
	Region LIKE ''%'' + @region + ''%'' OR Region IS NULL
	

' 
END
