﻿/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007 – 2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

using System;
using System.Collections.Generic;
using Eisk.BusinessEntities;
using Eisk.DataAccessLayer;

namespace Eisk.BusinessLogicLayer.Strategies.StoredProcedureWrapper
{
    [System.ComponentModel.DataObject(true)]
    public partial class EmployeeBLL : BusinessLogicComponentBase, IEmployeeBLL
    {
        public EmployeeBLL()
            : this(new DatabaseContext())
        {
        }

        public EmployeeBLL(DatabaseContext DatabaseContext)
            : base(DatabaseContext)
        {
        }

        #region Get Methods

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
        public Employee GetEmployeeByEmployeeId(int employeeId)
        {
            return (_DatabaseContext.Employees_GetEmployeeByEmployeeId(employeeId)[0]);
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
        public List<Employee> GetEmployeesByReportsTo(int? reportsTo)
        {
            return _DatabaseContext.Employees_GetEmployeesByReportsTo(reportsTo);
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
        public List<Employee> GetEmployeesByReportsToPaged(int? reportsTo, string orderBy, int startRowIndex, int maximumRows)
        {
            return _DatabaseContext.Employees_GetEmployeesByReportsTo_Paged(reportsTo, orderBy, startRowIndex, maximumRows);
        }

        public int GetTotalCountForAllEmployeesByReportsTo(int? reportsTo, string orderBy, int startRowIndex, int maximumRows)
        {
            return (int)_DatabaseContext.Employees_GetEmployeesByReportsTo_Paged_Count(reportsTo)[0];
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
        public List<Employee> GetAllEmployees()
        {
            return _DatabaseContext.Employees_GetAllEmployees();
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
        public List<Employee> GetAllEmployeesPaged(string orderBy, int startRowIndex, int maximumRows)
        {
            return _DatabaseContext.Employees_GetAllEmployees_Paged(orderBy, startRowIndex, maximumRows);
        }

        public int GetTotalCountForAllEmployees(string orderBy, int startRowIndex, int maximumRows)
        {
            return (int)_DatabaseContext.Employees_GetAllEmployees_Paged_Count()[0];

        }

        #endregion

        #region Persistence (Create, Update, Delete) Methods

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
        public int CreateNewEmployee(Employee newEmployee)
        {
            int numberOfAffectedRows = 0;

            /*int numberOfAffectedRows = _DatabaseContext.Employees_CreateNewEmployee
                (
                newEmployee.LastName,
                newEmployee.FirstName,
                newEmployee.Title,
                newEmployee.TitleOfCourtesy,
                newEmployee.BirthDate,
                newEmployee.HireDate,
                newEmployee.Address,
                newEmployee.City,
                newEmployee.Region,
                newEmployee.PostalCode,
                newEmployee.Country,
                newEmployee.HomePhone,
                newEmployee.Extension,
                newEmployee.Photo,
                newEmployee.Notes,
                newEmployee.ReportsTo,
                newEmployee.PhotoPath
                );
            */

            if (numberOfAffectedRows == 0) throw new InvalidOperationException("No employee created!");
            return 0;
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
        public void UpdateEmployee(Employee updatedEmployee)
        {
            
        }

        [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
        public void DeleteEmployee(Employee employeeToBeDeleted)
        {
            

        }

       public void DeleteEmployees(List<int> employeesIdsToDelete)
        {
            //List<Employee> employeesToBeDeleted = new List<Employee>();

            //foreach (int employeeId in employeesIdsToDelete)
            //{
            //    Employee employee = new Employee { EmployeeId = employeeId };
            //    _DatabaseContext.Employees.Attach(employee);
            //    _DatabaseContext.ObjectStateManager.ChangeObjectState(employee, System.Data.EntityState.Deleted);
            //    employeesToBeDeleted.Add(employee);
            //}

            //int numberOfAffectedRows = _DatabaseContext.SaveChanges();
            //if (numberOfAffectedRows != employeesIdsToDelete.Count) throw new InvalidOperationException("One or more employee records have not been deleted.");

            
        }

        #endregion
        
    }//end of Employee class
}

