﻿/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007 – 2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

using System;
using System.Collections.Generic;
using Eisk.BusinessEntities;

namespace Eisk.BusinessLogicLayer.Strategies
{
    [System.ComponentModel.DataObject(true)]
    public partial class StrategyProxyEmployeeBLL:IEmployeeBLL
    {
        dynamic _employeeBLL;

        public StrategyProxyEmployeeBLL()
        {
            //string configProvider = "Eisk.BusinessLogicLayer.Strategies.LinqToEntitiesWrapper.EmployeeBLL";
            //_employeeBLL = (IEmployeeBLL)Activator.CreateInstance(Type.GetType(configProvider));

            string configProvider = System.Configuration.ConfigurationSettings.AppSettings["BusinessLayerStrategy"];
            if (string.IsNullOrEmpty(configProvider) || configProvider == "Eisk.BusinessLogicLayer")
                _employeeBLL = new Eisk.BusinessLogicLayer.Strategies.LinqToEntitiesWrapper.EmployeeBLL();
            else
                _employeeBLL = Activator.CreateInstance(Type.GetType(configProvider + ".EmployeeBLL"));
        }

        //public StrategyProxyEmployeeBLL(dynamic employeeBLL)
        //{
        //    _employeeBLL = employeeBLL;
        //}

       public void Dispose()
        {
            _employeeBLL.Dispose();
        }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, true)]
       public Employee GetEmployeeByEmployeeId(int employeeId)
       {
           return (_employeeBLL.GetEmployeeByEmployeeId(employeeId));
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
       public List<Employee> GetEmployeesByReportsTo(int? reportsTo)
       {
           return _employeeBLL.GetEmployeesByReportsTo(reportsTo);
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
       public List<Employee> GetEmployeesByReportsToPaged(int? reportsTo, string orderBy, int startRowIndex, int maximumRows)
       {
           if(string.IsNullOrEmpty(orderBy))
               orderBy = "EmployeeId";

          return _employeeBLL.GetEmployeesByReportsToPaged( reportsTo, orderBy, startRowIndex, maximumRows);
       }

       public int GetTotalCountForAllEmployeesByReportsTo(int? reportsTo, string orderBy, int startRowIndex, int maximumRows)
       {
           return _employeeBLL.GetTotalCountForAllEmployeesByReportsTo(reportsTo, orderBy, startRowIndex, maximumRows);
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
       public List<Employee> GetAllEmployees()
       {
           return _employeeBLL.GetAllEmployees();
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Select, false)]
       public List<Employee> GetAllEmployeesPaged(string orderBy, int startRowIndex, int maximumRows)
       {
           if (string.IsNullOrEmpty(orderBy))
               orderBy = "EmployeeId";

           return _employeeBLL.GetAllEmployeesPaged (orderBy, startRowIndex, maximumRows);
       }

       public int GetTotalCountForAllEmployees(string orderBy, int startRowIndex, int maximumRows)
       {
           return _employeeBLL.GetTotalCountForAllEmployees(orderBy, startRowIndex, maximumRows);
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Insert, true)]
       public int CreateNewEmployee(Employee newEmployee)
       {
           return _employeeBLL.CreateNewEmployee(newEmployee);
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Update, true)]
       public void UpdateEmployee(Employee updatedEmployee)
       {
           _employeeBLL.UpdateEmployee(updatedEmployee);
       }

       [System.ComponentModel.DataObjectMethodAttribute(System.ComponentModel.DataObjectMethodType.Delete, true)]
       public void DeleteEmployee(Employee employeeToBeDeleted)
       {
           _employeeBLL.DeleteEmployee(employeeToBeDeleted);
       }

       public void DeleteEmployees(List<int> employeesIdsToDelete)
       {
           _employeeBLL.DeleteEmployees(employeesIdsToDelete);
       }
    }
}

