/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007  2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

using System.Configuration;
namespace Eisk.Helpers
{
    public sealed class ConfigHelper
	{
        ConfigHelper() { }

        public static void SaveConnectionStringKey(string configFilePhysicalPath, string key, string value)
        {
            ExeConfigurationFileMap m = new ExeConfigurationFileMap();
            m.ExeConfigFilename = configFilePhysicalPath;
            Configuration objConfig = System.Configuration.ConfigurationManager.OpenMappedExeConfiguration(m, ConfigurationUserLevel.None);
            ConnectionStringsSection objAppsettings = (ConnectionStringsSection)objConfig.GetSection("connectionStrings");
            if (objAppsettings != null)
            {
                objAppsettings.ConnectionStrings[key].ConnectionString = value;
                objConfig.Save();
            }
        }

        //public static void SaveDatabaseUnitTestingConnectionStringKey(string configFilePhysicalPath, string key, string value)
        //{
        //    ExeConfigurationFileMap m = new ExeConfigurationFileMap();
        //    m.ExeConfigFilename = configFilePhysicalPath;
        //    Configuration objConfig = System.Configuration.ConfigurationManager.OpenMappedExeConfiguration(m, ConfigurationUserLevel.None);
        //    //ConfigurationSectionGroup ss = objConfig.GetSection("DatabaseUnitTesting/ExecutionContext");
        //    ConfigurationSection c = objConfig.Sections["DatabaseUnitTesting"];
            
        //    //ConnectionStringsSection objAppsettings = (ConnectionStringsSection)objConfig.GetSection("connectionStrings");
        //    if (objAppsettings != null)
        //    {
        //        objAppsettings.ConnectionStrings[key].ConnectionString = value;
        //        objConfig.Save();
        //    }
        //}
	}
}
