﻿using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;

namespace Eisk.Web.App_Services
{
    [ServiceContract(Namespace = "")]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class Business_Service
    {
        [OperationContract]
        [WebInvoke(Method = "GET", ResponseFormat = WebMessageFormat.Json)]
        public List<Employee1> GetAllEmployees()
        {
            List<Employee1> lst = new List<Employee1>();
            Employee1 e = new Employee1 { EmployeeId = 100, FirstName = "Ashraful", Country = "USA", BirthDate = new DateTime(1979, 04, 12) };
            lst.Add(e);

            e = new Employee1 { EmployeeId = 200, FirstName = "Bill", BirthDate = new DateTime(1949, 04, 12) };
            lst.Add(e);

            return lst;

        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public Employee1 GetEmployeeByEmployeeId(int employeeId)
        {
            if (employeeId == 100)
                return new Employee1 { EmployeeId = 100, FirstName = "Ashraf", LastName = "MVP", BirthDate = new DateTime(1979, 04, 12) };
            if (employeeId == 200)
                return new Employee1 { EmployeeId = 200, FirstName = "Bill", LastName = "Gates" };
            return null;
        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public Employee1 UpdateEmployee(Employee1 updatedEmployee)
        {
            //return new Employee1 { EmployeeId = 100, FirstName = updatedEmployee.FirstName, LastName = "MVP" };\
            return updatedEmployee;
        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public Employee1 CreateNewEmployee(Employee1 newEmployee)
        {
            return new Employee1 { EmployeeId = 100, FirstName = newEmployee.FirstName, LastName = "MVP" };
        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public int DeleteEmployees(List<int> employeeIdsToDelete)
        {
            return employeeIdsToDelete.Count;
        }

        /**************************************************/
        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public Contact UpdateMyData(Contact contact)
        {
            contact.firstName = contact.firstName + "xx";
            return contact;
        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public Contact UpdateMyCollection(List<Contact> contacts)
        {
            contacts[0].firstName = contacts[0].firstName + "xx1";
            return contacts[0];
        }

        [OperationContract]
        [WebInvoke(Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        public string UpdateMyListCollection(List<Contact> contacts)
        {
            return contacts[0].phones[1].number + "x";
        }
    }

    public class Contact
    {
        public string firstName { get; set; }
        public string lastName { get; set; }
        public int age { get; set; }
        public List<Phone> phones { get; set; }
    }

    public class Phone
    {
        public string type { get; set; }
        public string number { get; set; }
    }

    public class Employee1
    {
        public int EmployeeId { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Country { get; set; }
        public DateTime? BirthDate { get; set; }
    }
}
