/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007  2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

var Employee_Service_Proxy = {

    GetAllEmployees: function (successCallback, failureCallback) {
        OData.read(
            "../App_Services/Data_Service.svc/Employees",
            function (data, request) {
                successCallback(data.results);
            },
            function (msg) {
                failureCallback(msg);
            });
    },
    GetEmployeeByEmployeeId: function (employeeId, successCallback, failureCallback) {
        OData.read(
            "../App_Services/Data_Service.svc/Employees(" + employeeId + ")",
            function (data, response) {
                successCallback(data);
            },
            function (msg) {
                failureCallback(msg);
            }
        );
    },
    UpdateEmployee: function (updatedEmployee, successCallback, failureCallback) {

        updatedEmployee.BirthDate = null;
        updatedEmployee.HireDate = '1/1/2010';
        updatedEmployee.Address = 'XYZ';
        updatedEmployee.HomePhone = '123';
        updatedEmployee.Country = 'US';

        OData.request(
            {
                method: "PUT",
                requestUri: "../App_Services/Data_Service.svc/Employees(" + updatedEmployee.EmployeeId + ")",
                data: updatedEmployee
            },
            function (data, response) {
                successCallback(data);
            },
            function (msg) {
                failureCallback(msg);
            }
        );
    },
    CreateNewEmployee: function (newEmployee, successCallback, failureCallback) {

        newEmployee.BirthDate = null;

        newEmployee.HireDate = '1/1/2010';
        newEmployee.Address = 'XYZ';
        newEmployee.HomePhone = '123';
        newEmployee.Country = 'US';

        OData.request(
            {
                method: "POST",
                requestUri: "../App_Services/Data_Service.svc/Employees",
                data: newEmployee
            },
            function (data, response) {
                successCallback(data);
            },
            function (msg) {
                failureCallback(msg);
            }
        );
    },
    DeleteEmployee: function (employeeIdToDelete, successCallback, failureCallback) {

        OData.request(
            {
                method: "DELETE",
                requestUri: "../App_Services/Data_Service.svc/Employees(" + employeeIdToDelete + ")"
            },
            function (data, response) {
                successCallback(data);
            },
            function (msg) {
                failureCallback(msg);
            }
        );
    },
    DeleteEmployees: function (employeeIdsToDelete, successCallback, failureCallback) {

        //        OData.request(
        //            {
        //                method: "POST",
        //                requestUri: "../App_Services/Business_Service.svc/DeleteEmployees",
        //                data: { employeeIdsToDelete: employeeIdsToDelete }
        //            },
        //            function (data, response) {
        //                successCallback(data);
        //            },
        //            function (msg) {
        //                failureCallback(msg);
        //            }
        //        );

        OData.request(
            {
                method: "DELETE",
                requestUri: "../App_Services/Data_Service.svc/Employees(" + employeeIdsToDelete[0] + ")"
            },
            function (data, response) {
                successCallback(data);
            },
            function (msg) {
                failureCallback(msg);
            }
        );
    }
};

