/****************** Copyright Notice *****************
 
This code is licensed under Microsoft Public License (Ms-PL). 
You are free to use, modify and distribute any portion of this code. 
The only requirement to do that, you need to keep the developer name, as provided below to recognize and encourage original work:

=======================================================
   
Architecture Designed and Implemented By:
Mohammad Ashraful Alam
Microsoft Most Valuable Professional, ASP.NET 2007  2011
Twitter: http://twitter.com/AshrafulAlam | Blog: http://blog.ashraful.net | Portfolio: http://www.ashraful.net
   
*******************************************************/

jQuery(function ($) {
    //--------------------- Employee Listing ------------------------------------------------------------------------

    function BindGrid() {
        Employee_Service_Proxy.GetAllEmployees(bindGridSuccessCallback, failureCallback);
    }

    var bindGridSuccessCallback = function (responseData) {
        $("#employeeListingTemplateContainer").empty();
        var returnedEmployeeCollection = responseData["d"];
        $("#employeeListingTemplate").tmpl({ employeeCollection: returnedEmployeeCollection }).appendTo("#employeeListingTemplateContainer");
    };

    var failureCallback = function (data) {
        alert('Request failure');
    };

    //----------- Employee Details (Container) for Add/Edit/View -----------------------------------------------------------------------------------

    $("#employeeDetailsTemplateContainer").dialog({
        autoOpen: false,
        height: 250,
        width: 550,
        modal: true
    });

    //----------- Employee Details (View) -----------------------------------------------------------------------------------

    //Create buttons for showing details
    $("#btnEmployeeDetails").live("click", function BindEmployeeDetails(e) {
        // Don't post back
        e.preventDefault();

        // Get employee
        var id = $(e.target).attr("data-id");
        Employee_Service_Proxy.GetEmployeeByEmployeeId(id, bindDetailsSuccessCallback, failureCallback);

    });

    var bindDetailsSuccessCallback = function (responseData) {
        $("#employeeDetailsTemplateContainer").empty();
        var returnedEmployee = responseData["d"];
        //var returnedEmployee = { FirstName: "Ashraful", LastName: "Alam" };
        $("#employeeDetailsTemplate").tmpl(returnedEmployee).appendTo("#employeeDetailsTemplateContainer");


        $("#employeeDetailsTemplateContainer").dialog("option", "title", returnedEmployee.FirstName);
        $("#employeeDetailsTemplateContainer").dialog("open");
    };

    //--------------Employee Add/Edit Details ------------------------------------------------------------------------------

    var editMode;
    var employee = {};

    //Create buttons for showing details
    $("#btnEmployeeEditDetails").live("click", function BindEmployeeEditDetails(e) {
        // Don't post back
        //e.preventDefault();

        editMode = "edit";

        // Get employee
        var id = $(e.target).attr("data-id");
        Employee_Service_Proxy.GetEmployeeByEmployeeId(id, bindEditDetailsSuccessCallback, failureCallback);

    });

    //Create buttons for showing details
    $("#btnEmployeeAddDetails").live("click", function BindEmployeeAddDetails(e) {
        // Don't post back
        e.preventDefault();

        editMode = "add";
        bindEditDetailsSuccessCallback();

    });

    var bindEditDetailsSuccessCallback = function (responseData) {
        $("#employeeDetailsTemplateContainer").empty();


        if (editMode == "edit") {
            employee = responseData["d"];
            $("#employeeDetailsTemplateContainer").dialog("option", "title", employee.FirstName);
        }
        else {
            employee = {};
            $("#employeeDetailsTemplateContainer").dialog("option", "title", "New Employee");
        }

        $("#employeeEditDetailsTemplate").tmpl(employee).appendTo("#employeeDetailsTemplateContainer");
        $("#employeeEditDetailsDiv").link(employee);

        $("#employeeDetailsTemplateContainer").dialog("open");


    };

    //--------------Employee Add/Edit Details (Save) ------------------------------------------------------------------------------

    $("#btnSaveEmployee").live("click", function (e) {
        // Don't post back
        e.preventDefault();

        if (editMode == "edit") {
            Employee_Service_Proxy.UpdateEmployee(employee, saveEmployeeSuccessCallback, failureCallback);
        }
        else {
            Employee_Service_Proxy.CreateNewEmployee(employee, saveEmployeeSuccessCallback, failureCallback);
        }

    });

    var saveEmployeeSuccessCallback = function (responseData) {
        returnedEmployee = responseData["d"];
        alert('success ' + returnedEmployee.FirstName + " Last Name: " + returnedEmployee.LastName + " BD: " + returnedEmployee.BirthDate);
    };

    //------------------------------------------ Delete Selected Employees -------------------------------------------------------------

    //    $("#chkSelectAll").click(function () {
    //        alert('clicked');
    //    });

    $("#btnDeleteSelectedEmployees").live("click", function BindEmployeeEditDetails(e) {
        var answer = confirm("Delete selected employees ?")
        if (answer) {
            var employeeIdsToDelete = new Array();

            $.each($("input[name='chkEmployee']:checked"), function () {
                employeeIdsToDelete.push($(this).attr("data-id"));
            });

            Employee_Service_Proxy.DeleteEmployees(employeeIdsToDelete, deleteSelectedEmployeesSuccessCallback, failureCallback);
        }
    });

    var deleteSelectedEmployeesSuccessCallback = function (responseData) {
        totalEmployees = responseData["d"];
        alert('success ' + totalEmployees);
    };

    //------------------------------------------ Page Load Event -------------------------------------------------------------

    // initial view on load
    BindGrid();
});

//------------------------- javascript ------------------------------------

function SelectAll(frmId, id) {

    var frm = document.getElementById(frmId);
    for (i = 1; i < frm.rows.length - 1; i++) {

        frm.rows[i].cells[0].childNodes[1].checked = document.getElementById(id).checked;

    }
};

    

