﻿<%@ Page Title="" Language="C#" MasterPageFile="~/App_Resources/default.master"
    AutoEventWireup="true" CodeBehind="about-this-sample.aspx.cs" Inherits="Eisk.Web.web_form_samples.about_this_sample" %>

<asp:Content ID="Content2" ContentPlaceHolderID="BodyContentPlaceholder" runat="server">
    <h1 class="title-regular clearfix">
        About Web Form Samples</h1>
    <p>
        See also: <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Installation%20Walk%20Through">
            Installation Walkthrough</a> - <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Hand%20on%20Coding%20Walkthrough">
                Hand on Coding Walkthrough</a> - <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Technical%20Reference">
                    Technical Reference</a></p>
    <p>
        Employee Info Starter Kit is an open source project that is highly influenced by
        the concept ‘Pareto Principle’ or 80-20 rule, where it is targeted to enable a web
        developer to gain 80% productivity with 20% of effort with respect to learning curve
        and production.<br />
        <br />
        It is intended to address different types of real world challenges faced by web
        application developers when performing common CRUD operations. Using a single database
        table ‘Employee’, the current release illustrates how to utilize Microsoft ASP.NET
        4.0 Web Form Data Controls, Entity Framework 4.0 and Visual Studio 2010 effectively
        in that context.</p>
    <h2 class="title-regular-2">
        User End Functional Specification</h2>
    <p>
        The user end functionalities of this starter kit are pretty simple and straight
        forward that are focused in to perform CRUD operation on employee records as described
        below.</p>
    <ul>
        <li>Creating a new employee record</li>
        <li>Read existing employee records</li>
        <li>Update an existing employee record</li>
        <li>Delete existing employee records</li>
    </ul>
    <h2 class="title-regular-2">
        Architectural Overview</h2>
    <ul>
        <li>Simple 3 layer architecture (presentation, business logic and data access layer)
        </li>
        <li>ASP.NET web form based user interface</li>
        <li>Built-in code generators for logical layers, implemented in Visual Studio default
            template engine (T4) </li>
        <li>Built-in Entity Framework entities as business entities (aka: data containers)
        </li>
        <li>Data Mapper design pattern based Data Access Layer, implemented in C# and Entity
            Framework</li>
        <li>Domain Model design pattern based Business Logic Layer, implemented in C#</li>
        <li>Object Model for Cross Cutting Concerns (such as validation, logging, exception
            management)</li>
    </ul>
    <h2 class="title-regular-2">
        Minimum System Requirements</h2>
    <ul>
        <li>Visual Studio 2010 (Web Developer Express Edition) or higher</li>
        <li>Sql Server 2005 (Express Edition) or higher</li>
    </ul>
    <h2 class="title-regular-2">
        Technology Utilized</h2>
    
    <h3 class="title-regular-3">Languages/Scripts</h3>
    
    <ul>
        <li>Browser side: JavaScript</li>
        <li>Web server side: C#</li>
        <li>Code Generation Template: T-4 Template </li>
    </ul>
    <h2 class="title-regular-3">
        Frameworks</h2>
    <ul>
        <li>.NET Framework 4.0</li>
        <li>JavaScript Framework: jQuery 1.5.1</li>
        <li>CSS Framework: 960 grid system</li>
    </ul>
    <h2 class="title-regular-3">
        .NET Framework Components</h2>
    <ul>
        <li>.NET Entity Framework</li>
        <li>.NET Optional/Named Parameters <em>(new in .net 4.0)</em></li>
        <li>.NET Tuple <em>(new in .net 4.0)</em></li>
        <li>.NET Extension Method</li>
        <li>.NET Lambda Expressions </li>
        <li>.NET Anonymous Type</li>
        <li>.NET Query Expressions</li>
        <li>.NET Automatically Implemented Properties</li>
        <li>.NET LINQ</li>
        <li>.NET Partial Classes and Methods</li>
        <li>.NET Generic Type</li>
        <li>.NET Nullable Type</li>
        <li>ASP.NET Meta Description and Keyword Support <em>(new in .net 4.0)</em></li>
        <li>ASP.NET Routing <em>(new in .net 4.0)</em></li>
        <li>ASP.NET Grid View (CSS support for sorting - <em>(new in .net 4.0)</em>)</li>
        <li>ASP.NET Repeater</li>
        <li>ASP.NET Form View</li>
        <li>ASP.NET Login View</li>
        <li>ASP.NET Site Map Path</li>
        <li>ASP.NET Skin</li>
        <li>ASP.NET Theme</li>
        <li>ASP.NET Master Page</li>
        <li>ASP.NET Object Data Source</li>
        <li>ASP.NET Role Based Security</li>
    </ul>
    <p>
        See also: <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Installation%20Walk%20Through">
            Installation Walkthrough</a> - <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Hand%20on%20Coding%20Walkthrough">
                Hand on Coding Walkthrough</a> - <a target="_blank" href="http://eisk.codeplex.com/wikipage?title=v5.0%20-%20ASP.NET%20Web%20Form%20Edition%3a%20Technical%20Reference">
                    Technical Reference</a></p>
</asp:Content>
